{
DELPHI 3 Componnent.

Par: Gabriel Cabot
     gcabot@globetrotter.qc.ca

Copyright notice:

This component is unrestricted freeware. It may be distributed, used and/or
modified without restriction. Please note that although this component has
been tested and been found to work correctly, you use it entirely at your
own risk and I will not be held responsible for any thing that may happend.}

{Ce composant est du domaine freeware. Il peut tre distribu, utilis et/ou
modifi sans restrictions. Veuillez noter que mme si ce composant  t test
and que tout fonctionnait bien, vous l'utilisez  vos propres risques et je
ne serai jamais tenu responsable pour aucune sorte de dommages.}

{This componnent is a small wrapper for TRegistry and has 3 simples
 methods which allow you to create, read and delete a key in
 the windows registry. The value of the keys created with this
 componnent are always strings. "This should be enought for almost
 all applications."
 The key is always a sub key of HKEY_CURRENT_USER.

 TgReg is a descendant of TComponnent.
 It's a componnent for Delphi 3.


 PROPERTIES:
 NAME            Type     Description
 ----------------------------------------------------------------
 Key             String   Name of the key.
 Value           String   Value to write or read.
 DefaultValue    String   Returned value if the key doesn't exist.

 METHODS:
 Name             Declaration
 -------------------------------------------------
 SetKey           SetKey(Key,Value:String):Boolean;
 Description:
 The SetKey method is used to open a key and write the
 value specified in the Value property.
 If the key doesn't exist SetKey create it and write
 the contents of the Value property.
 SetKey returns False if the operation fails and true
 if it's okay.

 GetKey          GetKey(Key:String):String;
 Description:
 The GetKey method returns the value of the key
 specified in the Key property. If the key doesn't
 exist then the method returns the value specified
 if the DefaultValue property.

 DelKey          DelKey(Key):Boolean;
 Description:
 The DelKey method deletes a key from the registry
 and returns True if it's okay and False if the
 operation fails.

 EVENTS:
 No event available.
}


{Ce composant encapsule l'unit TRegistry et fournie trois (3)
 mthodes simples qui permettent de crer, lire et effacer une
 cl de la base de registre. La valeur des cls cres avec ce
 composant sont de type Chaine (String). Cela suffit dans la
 plus part des applications.
 La cl est toujours une sous cl de HKEY_CURRENT_USER.

 TgReg est un descendant de TComposant.
 C'est un composant Delphi 3.


 PROPRITS:
 Nom             Type     Description
 ----------------------------------------------------------------
 Key             String   Nom de la cl.
 Value           String   Valeur a crire ou lue.
 DefaultValue    String   Valeur de retour si la cl n'existe pas.

 MTHODES:
 Nom             Dclaration
 -------------------------------------------------
 SetKey          SetKey(Key,Value:String):Boolean;
 Description:
 La mthode SetKey est utilis pour ouvrir une cl
 et y mettre la valeur spcifier dans value. Si la
 cl n'existe pas SetKey l'ajoute et y insre la
 valeur de Value. SetKey retourne vrai si l'criture
 russi et False dans le cas contraire.

 GetKey          GetKey(Key:String):String;
 Description:
 La mthode GetKey retourne la valeur de la cl
 dfini dans Key. Si la cl n'existe pas retourne
 la valeur spcifi dans la proprit DefaultValue.

 DelKey          DelKey(Key):Boolean;
 Description:
 La mthode DelKey supprime une cl de la base
 de registre et retourne Vrai si l'opration a
 russi et False dans le cas contraire.

 VENEMENTS:

 Aucun venement de disponible.
}


unit TgRegistry;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs;

type
  TgReg = class(TComponent)
  private
    { Dclarations prives }
    mKey : String;
    mValue : String;
    mDefault : String;

    Function pGetKey : String;
    Procedure pSetKey(Key:String);

    Function pGetValue : String;
    Procedure pSetValue(Value:String);

    Function pGetDefault:String;
    Procedure pSetDefault(DefaultValue:String);
  protected
    { Dclarations protges }
  public
    { Dclarations publiques }
    Function SetKey:Boolean;
    Function GetKey:String;
    Function DelKey:Boolean;
  published
    { Dclarations publies }
    property Key : String read pGetKey write pSetKey;
    property Value : String read pGetValue write pSetValue;
    Property DefaultValue : String Read pGetDefault Write pSetDefault;

  end;

procedure Register;

implementation
   Uses Registry;



procedure Register;
begin
  RegisterComponents('Gab', [TgReg]);
end;

Function TgReg.pGetKey:String;
Begin
   pGetKey := mKey;
End;

Procedure TgReg.pSetKey(Key:String);
Begin
   mKey := Key;
End;

Function TgReg.pGetValue:String;
Begin
   pGetValue := mValue;
End;

Procedure TgReg.pSetValue(Value:String);
Begin
   mValue := Value;
End;

Function TgReg.pGetDefault:String;
Begin
   pGetDefault := mDefault;
End;

Procedure TgReg.pSetDefault(DefaultValue:String);
Begin
   mDefault := DefaultValue;
End;


Function TgReg.SetKey:Boolean;
Var
   Registre : TRegistry;
   ECantOpenRegistryKey : Exception;
begin
   ECantOpenRegistryKey := Exception.Create('Impossible d''ouvrir ou de crer la cl spcifie dans la base de registre.');
   Registre := TRegistry.Create;
   If Not Registre.OpenKey(mKey,True) Then
   Begin
      Raise ECantOpenRegistryKey;
      Result := False;
      Exit;
   End;
   Registre.WriteString(mKey,mValue);
   Registre.CloseKey;
   Registre.Destroy;
   ECantOpenRegistryKey.Destroy;
   Result := True;
end;

Function TgReg.GetKey: String;
Var
   Registre : TRegistry;
Begin
   Registre := TRegistry.Create;
   If Not Registre.OpenKey(mKey,False) Then
   Begin
      Result := mDefault;
      Exit;
   End;
   Result := Registre.ReadString(mKey);
   Registre.CloseKey;
   Registre.Destroy;
End;

Function TgReg.DelKey:Boolean;
Var
   Registre : TRegistry;
Begin
   Registre := TRegistry.Create;
   If Not Registre.DeleteKey(mKey) Then
   Begin
      Result := False;
      Exit;
   End;
   Result := True;
   Registre.Destroy;
End;
end.
